'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// @flow

var XhrEvalChunkPlugin = function () {
  function XhrEvalChunkPlugin() {
    _classCallCheck(this, XhrEvalChunkPlugin);
  }

  _createClass(XhrEvalChunkPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      compiler.plugin('compilation', function compilerPlugin(compilation) {
        compilation.mainTemplate.plugin('require-ensure', function requireEnsurePlugin(source, chunk, hash) {
          var _this = this;

          var chunkFilename = this.outputOptions.chunkFilename;
          var chunkMaps = chunk.getChunkMaps();
          var chunkLoadTimeout = this.outputOptions.chunkLoadTimeout || 120000;
          var chunkUrl = this.requireFn + '.p + ' + this.applyPluginsWaterfall('asset-path', JSON.stringify(chunkFilename), {
            hash: '" + ' + this.renderCurrentHashCode(hash) + ' + "',
            hashWithLength: function hashWithLength(length) {
              return '" + ' + _this.renderCurrentHashCode(hash, length) + ' + "';
            },
            chunk: {
              id: '" + chunkId + "',
              hash: '" + ' + JSON.stringify(chunkMaps.hash) + '[chunkId] + "',
              hashWithLength: function hashWithLength(length) {
                var shortChunkHashMap = Object.keys(chunkMaps.hash).filter(function (chunkId) {
                  return typeof chunkMaps.hash[chunkId] === 'string';
                }).reduce(function (acc, chunkId) {
                  return _extends({}, acc, _defineProperty({}, chunkId, chunkMaps.hash[chunkId].substr(0, length)));
                }, {});
                return '" + ' + JSON.stringify(shortChunkHashMap) + '[chunkId] + "';
              },
              name: '" + (' + JSON.stringify(chunkMaps.name) + '[chunkId]||chunkId) + "'
            }
          });
          return this.asString(['if(installedChunks[chunkId] === 0)', this.indent(['return Promise.resolve();']), '', '// an Promise means "currently loading".', 'if(installedChunks[chunkId]) {', this.indent(['return installedChunks[chunkId][2];']), '}', '// start chunk loading', 'var timeout = setTimeout(onReadyStateChange, ' + chunkLoadTimeout + ');', 'function onReadyStateChange() {', this.indent(['if (xhr.readyState === 4 && xhr.status === 200) {', this.indent(['eval(xhr.responseText);', 'clearTimeout(timeout);', 'var chunk = installedChunks[chunkId];', 'if(chunk !== 0) {', this.indent(['if(chunk) chunk[1](new Error("Loading chunk " + chunkId + " failed."));', 'installedChunks[chunkId] = undefined;']), '}']), '}']), '}', 'var xhr = new XMLHttpRequest();', 'xhr.open("GET", ' + chunkUrl + ');', 'xhr.onreadystatechange = onReadyStateChange;', 'xhr.send();', '', 'var promise = new Promise(function(resolve, reject) {', this.indent(['installedChunks[chunkId] = [resolve, reject];']), '});', 'return installedChunks[chunkId][2] = promise;']);
        });
      });
    }
  }]);

  return XhrEvalChunkPlugin;
}();

exports.default = XhrEvalChunkPlugin;